package com.jiuqi.util.patterns;

import java.util.Map;
import com.jiuqi.util.StringUtils;

class VariablePattern implements IPattern
{
    private String name;
    private int length;
    
    public void parse(final String expression) throws PatternException {
        this.clear();
        if (expression == null) {
            return;
        }
        final int p = expression.lastIndexOf(58);
        if (p == -1) {
            this.name = expression;
            this.length = 0;
        }
        else {
            this.name = expression.substring(0, p);
            final String valStr = expression.substring(p + 1);
            if (StringUtils.isEmpty(valStr)) {
                this.length = 0;
            }
            else {
                try {
                    this.length = Integer.parseInt(valStr);
                }
                catch (final NumberFormatException e) {
                    throw new PatternException(e);
                }
            }
        }
    }
    
    @Override
    public String toString() {
        final StringBuffer buffer = new StringBuffer("${");
        if (this.length == 0) {
            buffer.append(this.name);
        }
        else {
            buffer.append(this.name).append(':').append(this.length);
        }
        buffer.append('}');
        return buffer.toString();
    }
    
    public void add(final IPattern pattern) {
    }
    
    public void add(final int index, final IPattern pattern) {
    }
    
    public void clear() {
        this.name = null;
        this.length = 0;
    }
    
    public IPattern get(final int index) {
        return null;
    }
    
    public String getExpression() {
        return this.name;
    }
    
    public int getLength() {
        return this.length;
    }
    
    public int getType() {
        return 1;
    }
    
    public int indexOf(final IPattern pattern) {
        return -1;
    }
    
    public void remove(final int index) {
    }
    
    public void setExpression(final String value) {
        try {
            this.parse(value);
        }
        catch (final PatternException ex) {
            this.clear();
        }
    }
    
    public void setLength(final int value) {
        this.length = value;
    }
    
    public int size() {
        return 0;
    }
    
    public int match(final String s, final int start, final Map values) {
        if (this.length == 0 || start + this.length > s.length()) {
            return -1;
        }
        return start + this.length;
    }
    
    public String replace(final ITranslator translator) {
        final String[] ret = translator.translate(this.name, this.length);
        if (ret == null) {
            return this.toString();
        }
        return (ret.length == 0) ? "" : ret[0];
    }
}
